SystemOrganization addCategory: #ConfigurationOfCTranslator!

Object subclass: #ConfigurationOfCTranslator
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCTranslator'!

!ConfigurationOfCTranslator class methodsFor: 'development support' stamp: 'Richo 2/22/2012 13:43'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCTranslator class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:43'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCTranslator class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:43'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCTranslator class methodsFor: 'private' stamp: 'Richo 2/22/2012 13:43'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCTranslator class methodsFor: 'metacello tool support' stamp: 'Richo 2/22/2012 13:43'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCTranslator class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:43'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCTranslator class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:43'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCTranslator class methodsFor: 'loading' stamp: 'Richo 2/22/2012 13:43'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCTranslator class methodsFor: 'accessing' stamp: 'Richo 2/22/2012 13:43'!
project

	^self new project! !

!ConfigurationOfCTranslator class methodsFor: 'development support' stamp: 'Richo 2/22/2012 13:43'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCTranslator methodsFor: 'baselines' stamp: 'Richo 2/22/2012 13:45'!
baseline10: spec
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec
			blessing: #baseline;
			repository: 'http://www.squeaksource.com/CTranslator';
			package: 'CTranslator']! !

!ConfigurationOfCTranslator methodsFor: 'baselines' stamp: 'Richo 3/21/2012 14:49'!
baseline20: spec
	<version: '2.0-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/CTranslator'.
		spec project: 'AST-Core' with: [
			spec
				className: 'ConfigurationOfRefactoringBrowser';
				versionString: #stable;
				loads: #('AST-Core');
				file: 'ConfigurationOfRefactoringBrowser';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec package: 'CTranslator' with: [
			spec requires: 'AST-Core']]! !

!ConfigurationOfCTranslator methodsFor: 'accessing' stamp: 'Richo 2/22/2012 13:43'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCTranslator methodsFor: 'symbolic versions' stamp: 'Richo 3/21/2012 14:49'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '3.0'.
! !

!ConfigurationOfCTranslator methodsFor: 'versions' stamp: 'Richo 2/22/2012 13:45'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec
			package: 'CTranslator' with: 'CTranslator-Richo.51']! !

!ConfigurationOfCTranslator methodsFor: 'versions' stamp: 'Richo 3/16/2012 13:54'!
version20: spec
	<version: '2.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec
			package: 'CTranslator' with: 'CTranslator-Richo.55']! !

!ConfigurationOfCTranslator methodsFor: 'versions' stamp: 'Richo 3/21/2012 14:49'!
version30: spec
	<version: '3.0' imports: #('2.0-baseline')>
	spec for: #common do: [
		spec
			package: 'CTranslator' with: 'CTranslator-Richo.55']! !
